from PyQt4 import QtCore, QtGui
import PyQt4.QtGui as QtWidgets

from Parameters import resource_path


class AboutDialog(QtWidgets.QDialog):

    def __init__(self, parent):
        super(AboutDialog, self).__init__(parent)
        
        pixmap = QtGui.QPixmap(resource_path('./img/about.png'))
        img = QtWidgets.QLabel(self)
        img.setPixmap(pixmap)
        
        info = QtWidgets.QTextEdit(self)
        info.setReadOnly(True)
        info.setFixedWidth(400)
        info.setFixedHeight(192)
        info.setHtml('<h3>Python Classification Toolbox</h3>' +
                     '&copy; 2016 Stefan Steidl<br>' +
                     'Pattern Recognition Lab<br>' +
                     'Computer Science Department 5<br>'+
                     'Friedrich-Alexander University Erlangen-Nuremberg<br>' +
                     '<a href="mailto:steidl@cs.fau.de">steidl@cs.fau.de</a><br><br>' +
                     '<font color="#909090"><i>Study popular machine learning algorithms and create your own implementations in Python for a deeper understanding of the algorithms!</i></font>'
                     )
        
        layout = QtWidgets.QHBoxLayout()
        layout.addWidget(img)
        layout.addWidget(info)
        layout.addStretch(1)
        
        box = QtWidgets.QWidget()
        box.setLayout(layout)
        
        # OK button
        self.button = QtWidgets.QDialogButtonBox(QtWidgets.QDialogButtonBox.Ok, QtCore.Qt.Horizontal, self)
        self.button.accepted.connect(self.accept)
        
        layout = QtWidgets.QVBoxLayout(self)
        layout.addWidget(box)
        layout.addStretch(1)
        layout.addWidget(self.button)
        
        self.setWindowTitle('About...')
